(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ngx-conditional-validation', ['exports', '@angular/forms'], factory) :
    (global = global || self, factory(global['ngx-conditional-validation'] = {}, global.ng.forms));
}(this, function (exports, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    /**
     * Utils validators
     */
    var   
    // @dynamic
    /**
     * Utils validators
     */
    UtilsValidator = /** @class */ (function () {
        function UtilsValidator() {
        }
        /**
         * Clean subscriptions for changes in control value
         * @param control controls array
         */
        /**
         * Clean subscriptions for changes in control value
         * @param {?} control controls array
         * @return {?}
         */
        UtilsValidator.cleanChangeSubscriptions = /**
         * Clean subscriptions for changes in control value
         * @param {?} control controls array
         * @return {?}
         */
        function (control) {
            var e_1, _a;
            if (!(control.changeSubscriptions instanceof Array)) {
                control.changeSubscriptions = [];
            }
            try {
                for (var _b = __values(control.changeSubscriptions), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var subscription = _c.value;
                    subscription.unsubscribe();
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            control.changeSubscriptions = [];
        };
        /**
         * Subscribe to changes in the values of the controls to validate the main control
         * @param control main control
         * @param controls controls array
         */
        /**
         * Subscribe to changes in the values of the controls to validate the main control
         * @param {?} control main control
         * @param {?} controls controls array
         * @return {?}
         */
        UtilsValidator.pushChangeSubscriptions = /**
         * Subscribe to changes in the values of the controls to validate the main control
         * @param {?} control main control
         * @param {?} controls controls array
         * @return {?}
         */
        function (control, controls) {
            var e_2, _a;
            if (!(control.changeSubscriptions instanceof Array)) {
                control.changeSubscriptions = [];
            }
            controls = this.toRealControls(control, controls);
            try {
                for (var controls_1 = __values(controls), controls_1_1 = controls_1.next(); !controls_1_1.done; controls_1_1 = controls_1.next()) {
                    var conditionControl = controls_1_1.value;
                    /** @type {?} */
                    var realControl = typeof conditionControl === 'string' ?
                        this.getControlByName(conditionControl, (/** @type {?} */ (control.parent))) :
                        conditionControl;
                    if (realControl === null) {
                        throw new Error("The \"" + conditionControl + "\" control does not exist.");
                    }
                    /** @type {?} */
                    var subscription = realControl.valueChanges.subscribe((/**
                     * @param {?} e
                     * @return {?}
                     */
                    function (e) { return control.updateValueAndValidity(); }));
                    control.changeSubscriptions.push(subscription);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (controls_1_1 && !controls_1_1.done && (_a = controls_1.return)) _a.call(controls_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
        };
        /**
         * Get the control object from group parent
         * @param name control name to get
         * @param group group parent
         */
        /**
         * Get the control object from group parent
         * @param {?} name control name to get
         * @param {?} group group parent
         * @return {?}
         */
        UtilsValidator.getControlByName = /**
         * Get the control object from group parent
         * @param {?} name control name to get
         * @param {?} group group parent
         * @return {?}
         */
        function (name, group) {
            for (var key in group.controls) {
                if (key === name) {
                    return group.controls[key];
                }
            }
            return null;
        };
        /**
         * Get abstract control array
         * @param control main control
         * @param controls abstract controls or abstract controls name
         */
        /**
         * Get abstract control array
         * @param {?} control main control
         * @param {?} controls abstract controls or abstract controls name
         * @return {?}
         */
        UtilsValidator.toRealControls = /**
         * Get abstract control array
         * @param {?} control main control
         * @param {?} controls abstract controls or abstract controls name
         * @return {?}
         */
        function (control, controls) {
            var e_3, _a;
            /** @type {?} */
            var data = [];
            if (!(controls instanceof Array)) {
                controls = [];
            }
            try {
                for (var controls_2 = __values(controls), controls_2_1 = controls_2.next(); !controls_2_1.done; controls_2_1 = controls_2.next()) {
                    var conditionControl = controls_2_1.value;
                    /** @type {?} */
                    var realControl = typeof conditionControl === 'string' ?
                        this.getControlByName(conditionControl, (/** @type {?} */ (control.parent))) :
                        conditionControl;
                    if (realControl === null) {
                        throw new Error("The \"" + conditionControl + "\" control does not exist.");
                    }
                    data.push(realControl);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (controls_2_1 && !controls_2_1.done && (_a = controls_2.return)) _a.call(controls_2);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return data;
        };
        return UtilsValidator;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Custom validation with condition
     * @param {?} state condition to set the validators
     * @param {?} validators validators array to set
     * @param {?=} controls controls to detect changes in their values
     * @return {?}
     */
    function custom(state, validators, controls) {
        return (/**
         * @param {?} control
         * @return {?}
         */
        function (control) {
            var e_1, _a;
            UtilsValidator.cleanChangeSubscriptions(control);
            UtilsValidator.pushChangeSubscriptions(control, UtilsValidator.toRealControls(control, controls));
            if (typeof state === 'function' && state.call(control.parent)) {
                try {
                    for (var validators_1 = __values(validators), validators_1_1 = validators_1.next(); !validators_1_1.done; validators_1_1 = validators_1.next()) {
                        var validator = validators_1_1.value;
                        /** @type {?} */
                        var errors = validator(control);
                        if (errors !== null) {
                            return errors;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (validators_1_1 && !validators_1_1.done && (_a = validators_1.return)) _a.call(validators_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            return null;
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Validation with condition equal to value
     * @param {?} conditions conditions like object (key is control name)
     * @param {?} validators validators array
     * @param {?=} controls controls to detect changes in their values
     * @return {?}
     */
    function equal(conditions, validators, controls) {
        return (/**
         * @param {?} control
         * @return {?}
         */
        function (control) {
            if (!(controls instanceof Array)) {
                controls = [];
            }
            /** @type {?} */
            var validate = true;
            var _loop_1 = function (controlName) {
                if (!conditions.hasOwnProperty(controlName)) {
                    return "continue";
                }
                /** @type {?} */
                var value = conditions[controlName];
                /** @type {?} */
                var conditionalControl = UtilsValidator.getControlByName(controlName, (/** @type {?} */ (control.parent)));
                if (conditionalControl && controls.findIndex((/**
                 * @param {?} e
                 * @return {?}
                 */
                function (e) { return e === conditionalControl; })) === -1) {
                    controls.push(conditionalControl);
                }
                if (conditionalControl !== null && conditionalControl.value !== value) {
                    validate = false;
                    return "break";
                }
            };
            for (var controlName in conditions) {
                var state_1 = _loop_1(controlName);
                if (state_1 === "break")
                    break;
            }
            return custom((/**
             * @return {?}
             */
            function () { return validate; }), validators, controls)(control);
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} condition
     * @param {?=} controls
     * @return {?}
     */
    function requiredIf(condition, controls) {
        return (/**
         * @param {?} control
         * @return {?}
         */
        function (control) {
            if (typeof condition === 'function') {
                return custom((/**
                 * @return {?}
                 */
                function () { return condition(); }), [forms.Validators.required], controls)(control);
            }
            else if (condition instanceof Object) {
                return equal(condition, [forms.Validators.required], controls)(control);
            }
            return null;
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var ConditionalValidators = {
        custom: custom,
        equal: equal,
        requiredIf: requiredIf,
    };

    exports.ConditionalValidators = ConditionalValidators;
    exports.UtilsValidator = UtilsValidator;
    exports.ɵa = custom;
    exports.ɵb = equal;
    exports.ɵc = requiredIf;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-conditional-validation.umd.js.map
