import { AbstractControl, FormGroup } from '@angular/forms';
import { Subscription } from 'rxjs';
export interface ExtraControl extends AbstractControl {
    changeSubscriptions: Subscription[];
}
/**
 * Utils validators
 */
export declare class UtilsValidator {
    /**
     * Clean subscriptions for changes in control value
     * @param control controls array
     */
    static cleanChangeSubscriptions(control: ExtraControl): void;
    /**
     * Subscribe to changes in the values of the controls to validate the main control
     * @param control main control
     * @param controls controls array
     */
    static pushChangeSubscriptions(control: ExtraControl, controls: (AbstractControl | string)[]): void;
    /**
     * Get the control object from group parent
     * @param name control name to get
     * @param group group parent
     */
    static getControlByName(name: string, group: FormGroup): AbstractControl;
    /**
     * Get abstract control array
     * @param control main control
     * @param controls abstract controls or abstract controls name
     */
    static toRealControls(control: AbstractControl, controls: (AbstractControl | string)[]): AbstractControl[];
}
